#include <bits/stdc++.h>
#define ll long long
using namespace std;
int main()
{
ll N,Q,m,t=0,l=0;
	cin >> N >> Q;
ll d[N],p[N],k[Q];
	for(int i=0;i<N;i++)
		{
			cin >> d[i] >> p[i];
		}
	for(int i=0;i<Q;i++)
	{
		cin >> k[i];	
	}
	for(int i=0;i<Q;i++)
	{
	l=0;m=0;t=0;
		for(int j=0;j<=k[i];j++)
		{
			if(j==d[m])
			{
				t+=p[m];
				m++;
			}
			if(t>0)
			{
				l++;
				t--;
			}
		}
		cout << l << endl;
	}
 return 0;
}